--/run print(string.format("Unhittable at 102.4%% - you have %.2f%%", GetDodgeChance() + GetBlockChance() + GetParryChance() + 5 + 1/(0.0625 + 0.956/(GetCombatRating(CR_DEFENSE_SKILL)/4.91850*0.04))))

Unhittable = LibStub("AceAddon-3.0"):NewAddon("Broker_Unhittable", "AceEvent-3.0", "AceBucket-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Unhittable")

local GetDodgeChance = GetDodgeChance
local GetParryChance = GetParryChance
local GetBlockChance = GetBlockChance
local UnitArmor = UnitArmor
local UnitDefense = UnitDefense
local GetCombatRating = GetCombatRating

local pLevel = UnitLevel("player")
local pClass = select(2, UnitClass("player"))

local fmt = string.format
local getMissChance, getDamageReduction, getResilienceEffect, getHexColor

local db

Unhittable.ldb = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("Broker_Unhittable", {
	type = "data source",
	icon = "Interface\\Icons\\Spell_Holy_DevotionAura",
	label = "Unhittable",
	text = "",
})

local defaults = {
	profile = {
		avoidColor = {0, 1, 0, 1},
		drColor = {0, .5, 1, 1},
		armorColor = {1, 1, 1, 1},
		headerColor = {0, .5, 1, 1},
		labelColor = {0, 1, 0, 1},
		valueColor = {1, 1, 1, 1},
		brokerLabel = 0,
		showFuBarAV = true,
		showFuBarAVBlock = false,
		showFuBarDR = true,
		showFuBarArmor = false,
		displayPrecisionFuBar = 2,
		showToolTipDefense = true,
		showToolTipCombat = true,
		showToolTipArmor = true,
		showToolTipDR = true,
		displayPrecisionToolTip = 2,
		showIcon = false,
		showText = true,
		baselineLevel = 0,
		alwaysUseBaseline = false,
	}
}

local function getOptions()
	local options = {
		name = "Unhittable",
		desc = L["Displays a variety of useful stats for tanking."],
		type = "group",
		childGroups = "tab",
		get = function(info)
			return db[info[#info]]
		end,
		set = function(info, value)
			db[info[#info]] = value
			Unhittable:UpdateDisplay()
		end,
		args = {
			color = {
				type = "group",
				name = L["Colors"],
				desc = L["Set the text colors."],
				get = function(info)
					return unpack(db[info[#info]])
				end,
				set = function(info, r, g, b)
					db[info[#info]] = {r, g, b, 1}
					Unhittable:UpdateDisplay()
				end,
				order = 3,
				args = {
					brokerHeader = {
						type = "header",
						name = L["Data Feed Colors"],
						order = 10,
					},
					avoidColor = {
						type = "color",
						name = L["Avoidance Color"],
						desc = L["Set the color of the avoidance percentage on the data feed."],
						width = "full",
						order = 11,
					},
					drColor = {
						type = "color",
						name = L["DR Color"],
						desc = L["Set the color of the damage reduction percentage on the data feed."],
						width = "full",
						order = 12,
					},
					armorColor = {
						type = "color",
						name = L["Armor Color"],
						desc = L["Set the color of the armor value on the data feed."],
						width = "full",
						order = 13,
					},
					tooltipHeader = {
						type = "header",
						name = L["Tooltip Colors"],
						order = 20,
					},
					headerColor = {
						type = "color",
						name = L["Header Color"],
						desc = L["Set the color of header text."],
						width = "full",
						order = 21,
					},
					labelColor = {
						type = "color",
						name = L["Label Color"],
						desc = L["Set the color of label text."],
						width = "full",
						order = 22,
					},
					valueColor = {
						type = "color",
						name = L["Value Color"],
						desc = L["Set the color of value text."],
						width = "full",
						order = 23,
					},
				},
			},
			broker = {
				type = "group",
				name = L["Data Feed"],
				desc = L["Control how values to displayed on the broker data feed."],
				order = 1,
				args = {
					showFuBarAV = {
						type = "toggle",
						name = L["Show Avoidance"],
						desc = L["Display the avoidance percentage on the data feed."],
						width = "full",
						order = 12,
					},
					showFuBarAVBlock = {
						type = "toggle",
						name = L["Include Block with Avoidance"],
						desc = L["Include block chance in the avoidance percentage on the data feed."],
						width = "full",
						order = 12.5,
					
					},
					showFuBarDR = {
						type = "toggle",
						name = L["Show Damage Reduction"],
						desc = L["Display the damage reduction percentage on the data feed."],
						width = "full",
						order = 13,
					},
					showFuBarArmor = {
						type = "toggle",
						name = L["Show Armor"],
						desc = L["Display the armor value on the data feed."],
						width = "full",
						order = 14,
					},
					brokerLabel = {
						type = "select",
						name = L["Label Style"],
						desc = L["Style of labels to display on the data feed."],
						values = { [0] = L["None"], [1] = L["Short"], [2] = L["Long"] },
						order = 11,
					},
					displayPrecisionFuBar = {
						type = "range",
						name = L["Display Precision"],
						desc = L["Number of decimal places displayed on the data feed."],
						min = 0,
						max = 4,
						step = 1,
						order = 10,
					},
					baselineLevel = {
						type = "range",
						name = L["Baseline Level (0 = Player level)"],
						desc = L["Baseline level is used in damage reduction and defense calculations."],
						softMin = 0,
						min = 0,
						softMax = UnitLevel("player") + 3,
						max = 83,
						step = 1,
						width = "full",
						order = 20,
					},
				},
			},
			tooltip = {
				type = "group",
				name = L["Tooltip"],
				desc = L["Control how values are displayed in the tooltip."],
				order = 2,
				args = {
					showToolTipDefense = {
						type = "toggle",
						name = L["Show Defense"],
						desc = L["Display the defense values."],
						width = "full",
						order = 1,
					},
					showToolTipCombat = {
						type = "toggle",
						name = L["Show Combat Table"],
						desc = L["Display the combat table values."],
						width = "full",
						order = 2,
					},
					showToolTipArmor = {
						type = "toggle",
						name = L["Show Armor"],
						desc = L["Display the armor values."],
						width = "full",
						order = 3,
					},
					displayPrecisionToolTip = {
						type = "range",
						name = L["Display Precision"],
						desc = L["Number of decimal places displayed in the tooltip."],
						min = 0,
						max = 4,
						step = 1,
						order = 0,
					},
				},
			},
		}
	}
	options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(Unhittable.db)
	options.args.profile.order = 100
	return options
end

function Unhittable:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("UnhittableDB", defaults)
	db = self.db.profile
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Broker Unhittable", getOptions)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker Unhittable", "Broker Unhittable")
end

function Unhittable:OnEnable()
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED", "UpdateDisplay")
	self:RegisterEvent("CHARACTER_POINTS_CHANGED", "UpdateDisplay")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "UpdateDisplay")
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("PLAYER_TALENT_UPDATE", "UpdateDisplay")
	self:RegisterBucketEvent("UNIT_INVENTORY_CHANGED", .2, "BucketUpdate")
	self:RegisterBucketEvent("UNIT_AURA", .2, "BucketUpdate")
end

function Unhittable:PLAYER_LEVEL_UP(_, level)
	pLevel = level
	--keep it at +3 if set
	if db.baselineLevel == pLevel + 2 then
		db.baselineLevel = pLevel + 3
	end
	self:UpdateDisplay()
end

function Unhittable:BucketUpdate(units)
	if units.player then
		self:UpdateDisplay()
	end
end

function Unhittable:UpdateDisplay()
	self:UpdateText()
end

local missK = pClass == "DRUID" and 0.972 or 0.956
function getMissChance()
  --1/Ad = 1/c + k/A
	--Where 
	--A is the amount of avoidance before diminishing returns
	--c is the cap for the avoidance stat
	--k is the constant for your class
	--Ad is the amount of avoidance after diminishing returns are applied (how much your avoidance actually increases)
	
	--your base miss is 5%,
	--c = 16 for miss (1/16 = 0.0625),
	--k = 0.956 for war/dk/pld, 0.972 for druid
	--and each point of defense skill increases your chance to be missed by 0.04%
	
	return 5 + 1/(0.0625 + missK/(GetCombatRatingBonus(CR_DEFENSE_SKILL)*0.04))
end

function getDamageReduction(level, base)
	if not level then level = pLevel end
	local baseArmor, effectiveArmor = UnitArmor("player")
	local armor = base and baseArmor or effectiveArmor

	local levelModifier = level
	if levelModifier > 59 then
		levelModifier = levelModifier + (4.5 * (levelModifier - 59))
	end
	local temp = armor / (85 * levelModifier + 400)
	local armorReduction = temp / (1 + temp)

	armorReduction = max(0, min(.75, armorReduction))
	armorReduction = armorReduction * 100

	return tonumber(fmt("%.4f", armorReduction))
end

function getResilienceEffect(level)
	local rating = GetCombatRating(CR_CRIT_TAKEN_MELEE)
	if rating == 0 then return rating end
	
	if not level then level = pLevel end
	if level < 34 then level = 34 end
	
	if level >= 70 then
		return rating/25/((82/52)*(131/63)^((level-70)/10))
	elseif level >= 60 then
		return rating/25/(82/(262-3*level))
	elseif level >= 10 then
		return rating/25/((level-8)/52)
	else
		return rating/25/(2/52)
	end
end

function getHexColor(color)
	--if not color[1] or not color[2] or not color[3] then return "ffffff" end
	return fmt("%02x%02x%02x", color[1] * 255, color[2] * 255, color[3] * 255)
end


function Unhittable:UpdateText()
	local level = db.baselineLevel > 0 and db.baselineLevel or pLevel
	local displayString = "|r"
	local formatString = fmt("%%s|cff%%s%%.%df%%%%|r ", db.displayPrecisionFuBar)
	
	if db.showFuBarAV then
		local av = GetDodgeChance() + GetParryChance() + getMissChance()
		local avb = GetDodgeChance() + GetParryChance() + getMissChance() + GetBlockChance()
		if db.brokerLabel == 1 then
			displayString = fmt("%s%s", displayString, L["Av:"])
		elseif db.brokerLabel == 2 then
			displayString = fmt("%s%s", displayString, L["Avoidance:"])
		end
		if db.showFuBarAVBlock then
			displayString = fmt(formatString, displayString, getHexColor(db.avoidColor), avb)
		else
			displayString = fmt(formatString, displayString, getHexColor(db.avoidColor), av)
		end
	end
	if db.showFuBarDR then
		if db.brokerLabel == 1 then
			displayString = fmt("%s%s", displayString, L["DR:"])
		elseif db.brokerLabel == 2 then
			displayString = fmt("%s%s", displayString, L["Damage Reduction:"])
		end
		displayString = fmt(formatString, displayString, getHexColor(db.drColor), getDamageReduction(level))
	end
	if db.showFuBarArmor then
		local _, totalArmor = UnitArmor("player")
		if db.brokerLabel == 1 then
			displayString = fmt("%s%s", displayString, L["Ar:"])
		elseif db.brokerLabel == 2 then
			displayString = fmt("%s%s", displayString, L["Armor:"])
		end
		displayString = fmt("%s|cff%s%d|r ", displayString, getHexColor(db.armorColor), totalArmor)
	end  
	
	self.ldb.text = displayString
end

--ldb functions
function Unhittable.ldb.OnClick(_, button)
	if button == "RightButton" then
		InterfaceOptionsFrame_OpenToCategory("Broker Unhittable")
	elseif button == "LeftButton" and db.showFuBarAV then
		db.showFuBarAVBlock = not db.showFuBarAVBlock
		Unhittable:UpdateDisplay()
	end
end

function Unhittable.ldb.OnTooltipShow(tooltip)
	if not tooltip or not tooltip.AddLine or not tooltip.AddDoubleLine then return end
	
	local calcLevel = db.baselineLevel > 0 and db.baselineLevel or pLevel
	
	local baseArmor, effectiveArmor, _, armorBuffs, armorDebuffs = UnitArmor("player")

	local defenseRating = GetCombatRating(CR_DEFENSE_SKILL)
	
	local baseDefense, armorDefense = UnitDefense("player")
	local totalDefense = baseDefense + armorDefense
	local defenseEffect = (totalDefense - calcLevel * 5) * 0.04

	local dodgeChance = GetDodgeChance()
	local parryChance = GetParryChance()
	local blockChance = GetBlockChance()
	local critChance = max(0, 5 - (defenseEffect - getResilienceEffect()))
	local crushChance = 0
	if (calcLevel - pLevel) > 3 then
		crushChance = 15 + max(0, (pLevel * 5 - totalDefense) * 0.02)
	end
	local missChance = getMissChance()
	
	local hitChance = dodgeChance + parryChance + blockChance + critChance + crushChance + missChance

	local formatPercentString = fmt("%%.%df%%%%", db.displayPrecisionToolTip)
	local hr, hg, hb = unpack(db.headerColor)
	local lr, lg, lb = unpack(db.labelColor)
	local vr, vg, vb = unpack(db.valueColor)
	
	tooltip:AddLine(_G["HIGHLIGHT_FONT_COLOR_CODE"] .. "Unhittable")
	tooltip:AddLine(" ")

	if db.showToolTipDefense then
		tooltip:AddLine(L["Defense Calculation"], hr, hg, hb)
		if baseDefense == totalDefense then
			tooltip:AddDoubleLine(L["Total Defense"], fmt("%d", totalDefense), lr, lg, lb, vr, vg, vb)
		else
			tooltip:AddDoubleLine(L["Total Defense"], fmt("%d (%d+%d)", totalDefense, baseDefense, armorDefense), lr, lg, lb, vr, vg, vb)
		end
		if pLevel == 80 then
			--just wanted a way to see how much i can play with defense rating. 1 skill = 4.91850 rating
			tooltip:AddDoubleLine(L["Defense Rating"], fmt("%d (%d)", defenseRating, -121.278*(5.6-(GetDodgeBlockParryChanceFromDefense()))), lr, lg, lb, vr, vg, vb)
		else
			tooltip:AddDoubleLine(L["Defense Rating"], fmt("%d", defenseRating), lr, lg, lb, vr, vg, vb)
		end
		tooltip:AddLine(" ")
	end

	if db.showToolTipCombat then
		tooltip:AddLine(L["Combat Table"], hr, hg, hb)
		tooltip:AddDoubleLine(L["Miss Chance"], fmt(formatPercentString, missChance), lr, lg, lb, vr, vg, vb)
		tooltip:AddDoubleLine(L["Dodge Chance"], fmt(formatPercentString, dodgeChance), lr, lg, lb, vr, vg, vb)
		tooltip:AddDoubleLine(L["Parry Chance"], fmt(formatPercentString, parryChance), lr, lg, lb, vr, vg, vb)
		tooltip:AddDoubleLine(L["Block Chance"], fmt(formatPercentString, blockChance), lr, lg, lb, vr, vg, vb)
		if critChance > 0 then
			tooltip:AddDoubleLine(L["Crit Chance"], fmt(formatPercentString, critChance), lr, lg, lb, vr, vg, vb)
		end
		if crushChance > 0 then
			tooltip:AddDoubleLine(L["Crush Chance"], fmt(formatPercentString, crushChance), lr, lg, lb, vr, vg, vb)
		end
		tooltip:AddDoubleLine(L["Hit Chance"], fmt(formatPercentString, hitChance), lr, lg, lb, vr, vg, vb)
		tooltip:AddLine(" ")
	end

	if db.showToolTipArmor then
		tooltip:AddLine(L["Armor"], hr, hg, hb)
		if baseArmor == effectiveArmor then
			tooltip:AddDoubleLine(L["Armor"], fmt("%d", effectiveArmor), lr, lg, lb, vr, vg, vb)
		else
			tooltip:AddDoubleLine(L["Base Armor"], fmt("%d", baseArmor), lr, lg, lb, vr, vg, vb)
			if armorBuffs > 0 then
				tooltip:AddDoubleLine(L["Armor Buffs"], fmt("+%d", armorBuffs), lr, lg, lb, vr, vg, vb)
			end
			if armorDebuffs < 0 then
				tooltip:AddDoubleLine(L["Armor Debuffs"], fmt("%d", armorDebuffs), lr, lg, lb, vr, vg, vb)
			end
			tooltip:AddDoubleLine(L["Total Armor"], fmt("%d", effectiveArmor), lr, lg, lb, vr, vg, vb)
		end
		tooltip:AddDoubleLine(L["Damage Reduction"].." ("..calcLevel..")", fmt(formatPercentString, getDamageReduction(calcLevel)), lr, lg, lb, vr, vg, vb)
		tooltip:AddLine(" ")
	end
end